// Autor: Burkhard Brauer  Berliner Strae:80    25421 Pinneberg						Pinneberg den 30.5.2002

#include "KdeLotto.moc"
#include "LottoZiehung.cpp"

double const KOSTEN_PRO_BLOCK=1.50;
double const GEBUEHREN=2.50;
double Spielkosten=0.0;
int AnzahlTipBloecke=0;
double Kosten=0.0;
long double Zinseszins=0.0;

QString Str,zStr;
char CStr[100];

int FeldXk[11][50],FeldYk[11][50];
bool Kreuz[11][50];
int ZaehlerKreuze[11];

unsigned int ZiehungNr=0;
double Jahre=0.0;
bool Start=false;
int ZyklusZeit=1; // 1ms

void KdeW::LottoScheinZeichnen()
{ int Zeile,Spalte,BlockNr,Zahl=0,x,y,xoffset,yoffset;
  timer->stop();
  dreiRichtige=vierRichtige=fuenfRichtige=fuenfRichtigePlus=sechsRichtige=0;
  ZiehungNr=0; Jahre=0.0; Start=false;
  Spielkosten=0.0; AnzahlTipBloecke=0; Kosten=0.0; Zinseszins=0.0;

  for(BlockNr=1;BlockNr<=10;BlockNr++)
  { ZaehlerKreuze[BlockNr]=0;
    for(Zahl=1;Zahl<=49;Zahl++)
       Kreuz[BlockNr][Zahl]=false;
  }
  ListBox1->clear(); ListBox2->clear();
  Label1->setText(""); Label2->setText("");
  Label3->setText("ZiehungNr:0") ;Label4->setText("Jahre:0");
  Label5->setText("Kosten:0.0 DM");
  x=y=0;
  xoffset=10;
  yoffset=10;
  for(BlockNr=1;BlockNr<=10;BlockNr++)
  {  y=Zahl=0;
     if (BlockNr==6)
     {yoffset=160;
      xoffset=10;
     }
     for(Zeile=1;Zeile<=7;Zeile++)
     { y+=20;x=0;
       for(Spalte=1;Spalte<=7;Spalte++)
       { x+=20;
         Zahl++;
           FeldXk[BlockNr][Zahl]=x+xoffset;
           FeldYk[BlockNr][Zahl]=y+yoffset;
       }
     } // Ende for(Zeile)
     xoffset+=150;
  }
  repaint(0,0, BILD_BREITE, BILD_HOEHE,true);
}  // Ende  LottoScheinZeichnen()

void KdeW::paintEvent(QPaintEvent *dummy)
{   int  BlockNr,Zahl;
    QPen pen(black,2,SolidLine);
    wMaler.begin(this);
    wMaler.setFont(QFont("courier",10,QFont::Bold));
    for(BlockNr=1;BlockNr<=10;BlockNr++)
    {  for(Zahl=1;Zahl<=49;Zahl++)
       {   wMaler.setRasterOp(CopyROP);
           wMaler.setPen(black);
           wMaler.setBrush(white);
           wMaler.drawRect(FeldXk[BlockNr][Zahl]-10,FeldYk[BlockNr][Zahl]-10,20,20);
           wMaler.setPen(red);
           zStr.sprintf("%2d",Zahl);
           if (Zahl<10)
             wMaler.drawText(FeldXk[BlockNr][Zahl]-12,FeldYk[BlockNr][Zahl]+5,zStr);
           else
             wMaler.drawText(FeldXk[BlockNr][Zahl]-9,FeldYk[BlockNr][Zahl]+5,zStr);
           if (Kreuz[BlockNr][Zahl]==true)
           { wMaler.setPen(pen);
             wMaler.moveTo(FeldXk[BlockNr][Zahl]-9,FeldYk[BlockNr][Zahl]-9);
             wMaler.lineTo(FeldXk[BlockNr][Zahl]+9,FeldYk[BlockNr][Zahl]+9);
             wMaler.moveTo(FeldXk[BlockNr][Zahl]+9,FeldYk[BlockNr][Zahl]-9);
             wMaler.lineTo(FeldXk[BlockNr][Zahl]-9,FeldYk[BlockNr][Zahl]+9);
           }
        }
      } // Ende (BlockNr)
   wMaler.end();
} // Ende paintEvent()


void KdeW::mousePressEvent(QMouseEvent *Maus)
{ int MausX,MausY,BlockNr,Zahl;
     MausX=Maus->x();
     MausY=Maus->y();
     QPen pen(black,2,SolidLine);
     wMaler.begin(this);
       wMaler.setPen(pen);
       wMaler.setFont(QFont("courier",12,QFont::Bold));
       AnzahlTipBloecke=0;
       for(BlockNr=1;BlockNr<=10;BlockNr++)
       { for(Zahl=1;Zahl<=49;Zahl++)
         {  if (MausX>FeldXk[BlockNr][Zahl]-9  && MausX<FeldXk[BlockNr][Zahl]+9)
            { if (MausY>FeldYk[BlockNr][Zahl]-9  && MausY<FeldYk[BlockNr][Zahl]+9)
              { zStr.sprintf("BlockNr:%2d, Zahl:%2d",BlockNr,Zahl);
                statusbar->message(zStr,1000);
                if (Kreuz[BlockNr][Zahl]==false && ZaehlerKreuze[BlockNr]<6)
                { wMaler.moveTo(FeldXk[BlockNr][Zahl]-9,FeldYk[BlockNr][Zahl]-9);
                  wMaler.lineTo(FeldXk[BlockNr][Zahl]+9,FeldYk[BlockNr][Zahl]+9);
                  wMaler.moveTo(FeldXk[BlockNr][Zahl]+9,FeldYk[BlockNr][Zahl]-9);
                  wMaler.lineTo(FeldXk[BlockNr][Zahl]-9,FeldYk[BlockNr][Zahl]+9);
                  Kreuz[BlockNr][Zahl]=true;
                  ZaehlerKreuze[BlockNr]++;
                }
                else if (Kreuz[BlockNr][Zahl]==true && ZaehlerKreuze[BlockNr]>0)
                { wMaler.setBrush(white);
                  wMaler.setPen(black);
						wMaler.drawRect(FeldXk[BlockNr][Zahl]-10,FeldYk[BlockNr][Zahl]-10,20,20);
                  wMaler.setBrush(white);
                  wMaler.setPen(red);
                  zStr.sprintf("%2d",Zahl);
						wMaler.drawText(FeldXk[BlockNr][Zahl]-7,FeldYk[BlockNr][Zahl]+5,zStr);
                  Kreuz[BlockNr][Zahl]=false;
                  ZaehlerKreuze[BlockNr]--;
                }
              } // MausX Bereich
            } // MausY Bereich
         } // Ende for(Zahl)
         if (ZaehlerKreuze[BlockNr]>0) AnzahlTipBloecke++;;
       } // Ende for(BlockNr)
    wMaler.end();
   Spielkosten=KOSTEN_PRO_BLOCK*AnzahlTipBloecke+GEBUEHREN;
}  // Ende mousePressEvent()


void KdeW::vergleichen()
{  int BlockNr,Zahl,AnzahlRichtige;
   bool fuenfPlus;
   boolSechsRichtige=false;
   for(BlockNr=1;BlockNr<=10;BlockNr++)
   {   AnzahlRichtige=0;
       fuenfPlus=false;
       for(Zahl=1;Zahl<=49;Zahl++)
       { if (Kreuz[BlockNr][Zahl] && Zahl_im_Index[Zahl])
             AnzahlRichtige++;
         else if(Kreuz[BlockNr][Zahl] &&  GezogeneZahl[7]==Zahl )
             fuenfPlus=true;
       }
       if(AnzahlRichtige==3)
         dreiRichtige++;
       else if (AnzahlRichtige==4)
         vierRichtige++;
       else if (AnzahlRichtige==5)
         if (fuenfPlus)
           fuenfRichtigePlus++;
         else
           fuenfRichtige++;
       else if (AnzahlRichtige==6)
       {  sechsRichtige++;
          boolSechsRichtige=true;
       }
   } // ende for(BlockNr)
} // Ende vergleichen()


void KdeW::NeuerSchein_clicked()
{ LottoScheinZeichnen();
  ListBox1->clear();
  ListBox2->clear();
} // Ende  NeuerSchein_clicked()

void KdeW::ButtonAutoTip_clicked()
{ int Block,n;
  LottoScheinZeichnen();
  for (Block=1;Block<=10;Block++)
  { 	Ziehung();
  		for (n=1;n<=6;n++)
   	{	Kreuz[Block][GezogeneZahl[n]]=true;
         ZaehlerKreuze[Block]++;
      }
  }
  Spielkosten=KOSTEN_PRO_BLOCK*AnzahlTipBloecke+GEBUEHREN;
  repaint(0,0, BILD_BREITE, BILD_HOEHE,true);
}

void KdeW::ButtonStartStop_clicked()
{  int BlockNr,Zahl;
     ListBox2->clear();
   for(BlockNr=1;BlockNr<=10;BlockNr++)
   { Str="";
       for(Zahl=1;Zahl<=49;Zahl++)
       { if(Kreuz[BlockNr][Zahl]==true)
         {  zStr.sprintf("%2d ",Zahl);
            Str+=zStr;
         }
       }
       if(Str!="") ListBox2->insertItem(Str);
   } //ende for(BlockNr)
   if(Start==false)
   {	timer->start(ZyklusZeit,false);
     	Start=true;
   }
   else
   {  timer->stop();
      Start=false;
   }
}  // Ende  ButtonStartStop_clicked()


void KdeW::ButtonStep_clicked()
{   int BlockNr,Zahl,n;
    timer->stop();
    Start=false;
    ListBox2->clear();
    Kosten+=Spielkosten;
    Zinseszins=Zinseszins*1.000576923+Spielkosten;
    for(BlockNr=1;BlockNr<=10;BlockNr++)
    { Str="";
      for(Zahl=1;Zahl<=49;Zahl++)
      { if(Kreuz[BlockNr][Zahl]==true)
        {  zStr.sprintf("%2d ",Zahl);
           Str+=zStr;
        }
      }
     if(Str!="") ListBox2->insertItem(Str);
    } //ende for(BlockNr)
    Ziehung();
    ZiehungNr++;
    vergleichen();
    Jahre=(float)ZiehungNr/52.0;
    Str="";
    for (n=1;n<=6;n++)
    {  zStr.sprintf("%2d ",GezogeneZahl[n]);
       Str+=zStr;
    }
    Label1->setText(Str);
    zStr.sprintf("%2d ",GezogeneZahl[7]);
    Label2->setText(zStr);
    zStr.sprintf("ZiehungNr:%7d ",ZiehungNr);
    Label3->setText(zStr);
    zStr.sprintf("Jahre:%7.2f ",Jahre);
    Label4->setText(zStr);
    zStr.sprintf("Kosten:%7.2f DM",Kosten);
    Label5->setText(zStr);
    sprintf(CStr,"Kapital bei 3 Prozent Verzinsung = %1.6LE DM",Zinseszins);  // long
    statusbar->message(CStr);
    ZeigeAnzahlRichtige();
} //Ende ButtonStep_clicked()



void KdeW::timerZiehungen()
{ int n;
  do
  { Ziehung();
    ZiehungNr++;
    vergleichen();
    Kosten+=Spielkosten;
    Zinseszins=Zinseszins*1.000576923+Spielkosten;
    if(SechsRichtigeStop && boolSechsRichtige)
    { timer->stop();
      Start=false;
		break;
    }
  } while(ZiehungNr % 520!=0);    // 10 Jahre = 520 Monate
  Jahre=(float)ZiehungNr/52.0;
  Str="";
  for (n=1;n<=6;n++)
  {  zStr.sprintf("%2d ",GezogeneZahl[n]);
     Str+=zStr;
  }
  Label1->setText(Str);
  sprintf(CStr,"%2d ",GezogeneZahl[7]);
  Label2->setText(CStr);
  sprintf(CStr,"ZiehungNr:%7d ",ZiehungNr);
  Label3->setText(CStr);
  sprintf(CStr,"Jahre:%7.2f ",Jahre);
  Label4->setText(CStr);
  sprintf(CStr,"Kosten:%7.2f DM",Kosten);
  Label5->setText(CStr);
  sprintf(CStr,"Kapital bei 3 Prozent Verzinsung = %1.6LE DM",Zinseszins);
  statusbar->message(CStr);

  ZeigeAnzahlRichtige();

} // Ende timerZiehungen()

void KdeW::ZeigeAnzahlRichtige()
{   ListBox1->clear();
    sprintf(CStr,"Anzahl 3  Richtige:%7d",dreiRichtige);
    ListBox1->insertItem(CStr);
    sprintf(CStr,"Anzahl 4  Richtige:%7d",vierRichtige);
    ListBox1->insertItem(CStr);
    sprintf(CStr,"Anzahl 5  Richtige:%7d",fuenfRichtige);
    ListBox1->insertItem(CStr);
    sprintf(CStr,"Anzahl 5+ Richtige:%7d",fuenfRichtigePlus);
    ListBox1->insertItem(CStr);
    sprintf(CStr,"Anzahl 6  Richtige:%7d",sechsRichtige);
    ListBox1->insertItem(CStr);
} // Ende ZeigeAnzahlRichtige()



void KdeW:: ButtonInfo_clicked()
{  int Taste;
	Taste=MessageBox->information(this,"eMail:BurkhradBrauer@t-online.de",
                                 "Ich bin arm geblieben und Sie knnen das auch.\n"
                                 "               Mit Lotto! ","&OK");
}  //Ende ButtonInfo_clicked()


void KdeW::BoxChecked()
{   if (Ch1->isChecked()) SechsRichtigeStop=true;
    else  SechsRichtigeStop=false;
} // Ende BoxChecked()

void KdeW::ListItemIndex(int i)
{ statusbar->message(ListBox1->text(i),2000);
}
//---------------------------- Main ---------------------------------------------
int main(int argc, char* argv[])
{ StartWertZufall();
  KApplication* app = new KApplication(argc, argv,"KDE-QT KdeButton test!");
  KdeW *Fenster=new KdeW();
  Fenster->show();
  int r = app->exec();
  return r;
}//ENDE int main(int argc, char* argv[])

